package net.lucamasini.testcase.server.boundary;

import net.lucamasini.testcase.server.boundary.resource.HasFindByTypedId;
import net.lucamasini.testcase.server.boundary.resource.HasSaveOrUpdate;
import net.lucamasini.testcase.shared.entity.Ordine;

import javax.enterprise.context.Dependent;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.transaction.Transactional;

@Dependent
@Transactional
public class OrdiniService implements HasFindByTypedId<Ordine, String>, HasSaveOrUpdate<Ordine> {

    @Inject
    EntityManager em;

    public Ordine findOrdineById(String id) {
        return HasFindByTypedId.super.findByTypeId(id);
    }

    @Override
    public EntityManager getEm() {
        return em;
    }

    @Override
    public Class<Ordine> getEntityType() {
        return Ordine.class;
    }
}
