package net.lucamasini.testcase.server.boundary.resource;

import net.lucamasini.testcase.shared.common.ResponseMessages;

import javax.ws.rs.*;

import static javax.ws.rs.core.MediaType.APPLICATION_JSON;
import static javax.ws.rs.core.Response.Status.BAD_REQUEST;
import static javax.ws.rs.core.Response.Status.NOT_FOUND;

public interface HasFindById<T> extends IsResource<T> {

    @GET
    @Path("{id}")
    @Produces(APPLICATION_JSON)
    default T findById(@PathParam("id") Long id) {
        if (id == null) {
            throw new WebApplicationException(ResponseMessages.REMOTE_CALL_ERROR, BAD_REQUEST);
        }

        final T entity = getEm().find(getEntityType(), id);
        if (entity == null) {
            throw new WebApplicationException(String.format(ResponseMessages.ENTITY_NOT_FOUND, getEntityType(), id), NOT_FOUND);
        }
        return entity;
    }
}
