package net.lucamasini.testcase.server.boundary.resource;

import net.lucamasini.testcase.shared.common.ResponseMessages;

import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Response;


public interface HasFindByTypedId<TEntity, TId> extends IsResource<TEntity> {
    default TEntity findByTypeId(TId id) {
        if (id == null) {
            throw new WebApplicationException(ResponseMessages.REMOTE_CALL_ERROR, Response.Status.BAD_REQUEST);
        }

        final TEntity entity = getEm().find(getEntityType(), id);
        if (entity == null) {
            throw new WebApplicationException(String.format(ResponseMessages.ENTITY_NOT_FOUND, getEntityType(), id), Response.Status.NOT_FOUND);
        }
        return entity;
    }
}
