package net.lucamasini.testcase.server.control;

import net.lucamasini.testcase.shared.entity.ContatoreComanda;
import lombok.extern.slf4j.Slf4j;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.LockModeType;
import java.sql.Timestamp;
import java.util.Calendar;

@ApplicationScoped
@Slf4j public class ContatoreComandaControl {

    @Inject
    EntityManager em;

    public Long getNumeroComanda(String idBar) {

        Calendar d = Calendar.getInstance();
        d.set(Calendar.MILLISECOND, 0);
        d.set(Calendar.SECOND, 0);
        d.set(Calendar.MINUTE, 0);
        d.set(Calendar.HOUR_OF_DAY, 0);

        ContatoreComanda contatore = em.find(ContatoreComanda.class, idBar, LockModeType.PESSIMISTIC_WRITE);

        if (contatore == null) {
            contatore = new ContatoreComanda();
        }

        if (contatore.getData() == null || contatore.getData().before(d.getTime())) {
            log.info(String.format("Azzero il contatore per il negozio %s. Trovato %s, nuova data %s", idBar, contatore.getData(), d.getTime()));
            contatore.setData(new Timestamp(d.getTimeInMillis()));
            contatore.setIdBar(idBar);
            contatore.setContatore(0L);
        }

        contatore.setContatore(contatore.getContatore() + 1L);

        contatore = em.merge(contatore);
        em.lock(contatore, LockModeType.NONE);

        return contatore.getContatore();

    }


}
