package net.lucamasini.testcase.server.control;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Type;

@ApplicationScoped
@NoArgsConstructor
@AllArgsConstructor
public class FakeJsonb {

    @Inject
    private ObjectMapper objectMapper;

    public <T> String toJson(T object) {
        try {
            return objectMapper.writeValueAsString(object);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
    }

    public <T> T fromJson(InputStream is, Type type) {
        try {
            return objectMapper.readValue(is, objectMapper.constructType(type));
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
