package net.lucamasini.testcase.server.control;

import javax.enterprise.context.Dependent;
import javax.inject.Inject;
import javax.servlet.http.HttpServletRequest;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

@Dependent
public class OrdineControl {

    @Inject
    HttpServletRequest request;

    public String generaOrdineId(Long numeroComanda) {

        DateFormat format = new SimpleDateFormat("ddMMYYhhmmss");
        String ipAddress = request.getRemoteAddr();
        if (ipAddress == null) {
            ipAddress = request.getHeader("X-FORWARDED-FOR");
        }

        String codiceOperatore = ipToHex(ipAddress);

        String id = String.format("9999%s%06d%s",
                codiceOperatore,
                numeroComanda,
                format.format(new Date()));

        return id;
    }

    private String ipToHex(String reqIpAddr) {
        StringBuilder hex = new StringBuilder();
        String[] part = reqIpAddr.split("[\\.,]");
        if (part.length < 4) {
            return "00000000";
        }
        //escludo il primo ottetto che è sempre 10
        for (int i = 1; i < 4; i++) {
            int decimal = Integer.parseInt(part[i]);
            if (decimal < 16) // Append a 0 to maintian 2 digits for every number
            {
                hex.append('0');
                hex.append(String.format("%01X", decimal));
            } else {
                hex.append(String.format("%01X", decimal));
            }
        }
        return hex.toString();
    }

}