package net.lucamasini.testcase.shared.dto;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import net.lucamasini.testcase.shared.entity.MonitorPostazione;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.List;


@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Portable
public class AnteprimaMonitor {
    private long idMonitor;
    private List<MonitorPostazione> postazioni;
    private long totalePiattiInCarico;
    private long totalePiattiAperti;


    public AnteprimaMonitor(long monitor, List<MonitorPostazione> postazioni) {
        this.idMonitor = monitor;
        this.postazioni = postazioni;
        this.totalePiattiInCarico = postazioni.stream().mapToLong(MonitorPostazione::getNumeroPiattiInCarico).reduce(0, Long::sum);
        this.totalePiattiAperti = postazioni.stream().mapToLong(MonitorPostazione::getNumeroPiattiAperti).reduce(0, Long::sum);
    }


    @Override
    public String toString() {
        return "AnteprimaMonitor{" +
                "idMonitor=" + idMonitor +
                ", postazioni=" + postazioni +
                ", totalePiattiInCarico=" + totalePiattiInCarico +
                ", totalePiattiAperti=" + totalePiattiAperti +
                '}';
    }
}
