package net.lucamasini.testcase.shared.dto;

import lombok.AllArgsConstructor;
import lombok.Getter;
import net.lucamasini.testcase.shared.dto.manager.AbstractLayoutManager;
import net.lucamasini.testcase.shared.dto.manager.AppManager;
import net.lucamasini.testcase.shared.dto.manager.ChioscoManager;
import net.lucamasini.testcase.shared.dto.manager.ServitoManager;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

@Portable
@Getter
@AllArgsConstructor
public enum Canale {
    APP("LIGHT_GREEN", "A"){
        @Override
        public AbstractLayoutManager getManager() {
            return new AppManager();
        }
    },
    CHIOSCO("TEAL", "C"){
        @Override
        public AbstractLayoutManager getManager() {
            return new ChioscoManager();
        }
    },
    SERVITO("ORANGE", "S"){
        @Override
        public AbstractLayoutManager getManager() {
            return new ServitoManager();
        }
    };

    private final String color;

    private final String comandaPrefix;

    public static List<Canale> getCanali(Collection<String> strings) {
        List<Canale> canali = new ArrayList<>();
        for (String s : strings) {
            canali.add(Canale.valueOf(s));
        }
        return canali;
    }

    public abstract AbstractLayoutManager getManager();
}