package net.lucamasini.testcase.shared.dto;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import net.lucamasini.testcase.shared.entity.BarLayout;
import net.lucamasini.testcase.shared.entity.Ordine;
import net.lucamasini.testcase.shared.qualifiers.Publisher;

import javax.enterprise.inject.Instance;
import javax.enterprise.inject.spi.CDI;
import javax.enterprise.util.AnnotationLiteral;

@AllArgsConstructor
@NoArgsConstructor
@Getter
public abstract class ContestoStato {

    protected BarLayout barLayout;
    protected abstract ActionStati actions();

    public abstract Ordine getOrdine();

    public void publish(Device... destinations) {

        Instance<StateUpdatePublisher> stateUpdatePublishers = CDI.current().select(StateUpdatePublisher.class, new AnnotationLiteral<Publisher>() {});

        for(StateUpdatePublisher publisher: stateUpdatePublishers) {
            publisher.publish(getOrdine(), destinations);
        }
    }
}