package net.lucamasini.testcase.shared.dto;

import javax.enterprise.inject.Alternative;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Alternative
public class DatiUtente implements Serializable {

    private String username;
    private String firstName;
    private String lastName;
    private List<String> userRoles = new ArrayList<>();
    private Map<String, String> userParameters = new HashMap<>();

    public static final String CODICE_NEGOZIO = "CODNEG";
    public static final String SOCIETA = "SOC";
    public static final String CHIOSCO = "CHIOSCO";

    public DatiUtente() {
    }

    private String capitalize(String s) {
        return s != null ? s.substring(0, 1).toUpperCase().concat(s.toLowerCase().substring(1, s.length())) : "";
    }

    public String getUsername() {
        return username;
    }

    public String nomeCompleto() {
        return firstName + " " + lastName;
    }

    public String getFirstName() {
        return firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public Map<String, String> getUserParameters() {
        return userParameters;
    }

    public void setUserParameters(Map<String, String> userParameters) {
        this.userParameters = userParameters;
    }

    public String getIdBar() {
        return userParameters.get(DatiUtente.SOCIETA) + "-" + userParameters.get(DatiUtente.CODICE_NEGOZIO);

    }

    public List<String> getUserRoles() {
        return userRoles;
    }
}
