package net.lucamasini.testcase.shared.dto;

import lombok.*;
import net.lucamasini.testcase.shared.entity.Ordine;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import static net.lucamasini.testcase.shared.dto.StatoOrdine.*;

@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MonitorOrdini {

    private List<String> ordiniPronti;
    private List<String> ordiniInPreparazione;

    public MonitorOrdini(List<Ordine> ordini) {
        ordiniInPreparazione = ordini.stream().filter(o -> Arrays.asList(PIATTI_IN_PREPARAZIONE, BEVANDE_IN_PREPARAZIONE).contains(o.getStato())).map(Ordine::getNumeroComanda).collect(Collectors.toList());
        ordiniPronti = ordini.stream().filter(o -> IN_CONSEGNA.equals(o.getStato())).map(Ordine::getNumeroComanda).collect(Collectors.toList());
    }

}