package net.lucamasini.testcase.shared.dto.manager;

import net.lucamasini.testcase.shared.dto.StatoOrdine;

public class ChioscoManager extends BackManager {
    @Override
    public void postChiuso(StatoOrdine.OrdineContestoStato context) {
        if (context.getOrdine().hasSoloAVistaDaFare()) {
            StatoOrdine.BEVANDE_IN_PREPARAZIONE.cambiaStato(context);
        }
    }

    @Override
    public void postBevandeInPreparazione(StatoOrdine.OrdineContestoStato context) {
        super.postBevandeInPreparazione(context);
        if (context.getOrdine().hasSoloAVistaDaFare()) {
            StatoOrdine.IN_CONSEGNA.cambiaStato(context);
        }
    }

    @Override
    public void postInConsegna(StatoOrdine.OrdineContestoStato context) {
        super.postInConsegna(context);
        if (context.getOrdine().hasSoloAVistaDaFare()) {
            StatoOrdine.CONSEGNATO.cambiaStato(context);
        }
    }
}
