package net.lucamasini.testcase.shared.dto.manager;

import net.lucamasini.testcase.shared.dto.StatoOrdine;
import net.lucamasini.testcase.shared.dto.StatoPiattoOrdinato;
import net.lucamasini.testcase.shared.entity.Ordine;
import net.lucamasini.testcase.shared.entity.Piatto;
import net.lucamasini.testcase.shared.entity.PiattoOrdinato;

import java.util.Arrays;
import java.util.List;

public class FrontManager extends AbstractLayoutManager {
    @Override
    public void postChiuso(StatoOrdine.OrdineContestoStato context) {
        Ordine ordine = context.getOrdine();

        ordine.getPiattiOrdinati().stream()
                .filter(po -> po.getPiatto().getPreparazione() != Piatto.Preparazione.CUCINA && po.getStato() != StatoPiattoOrdinato.CANCELLATO)
                .forEach(po-> StatoPiattoOrdinato.PRONTO.cambiaStato(new StatoPiattoOrdinato.PiattoOrdinatoContestoStato(po, context.getBarLayout())));

        if (!ordine.hasPiattiForPreparazioneAndStato(Arrays.asList(Piatto.Preparazione.CUCINA), Arrays.asList(StatoPiattoOrdinato.APERTO))) {
            StatoOrdine.EVASO.cambiaStato(context);
        }

    }

    @Override
    public void postEvaso(StatoOrdine.OrdineContestoStato context) {
        for (PiattoOrdinato po : context.getOrdine().getPiattiOrdinati()) {
            if (po.getStato() == StatoPiattoOrdinato.PRONTO) {
                StatoPiattoOrdinato.EVASO.cambiaStato(new StatoPiattoOrdinato.PiattoOrdinatoContestoStato(po, context.getBarLayout()));
            }
        }
    }

    @Override
    public void postPronto(StatoPiattoOrdinato.PiattoOrdinatoContestoStato context) {
        Ordine ordine = context.getPiattoOrdinato().getOrdine();
        List<StatoPiattoOrdinato> stati = Arrays.asList(StatoPiattoOrdinato.PRONTO, StatoPiattoOrdinato.CANCELLATO);
        boolean allDone = ordine.getPiattiOrdinati().stream().allMatch(po -> stati.contains(po.getStato()));

        if (StatoOrdine.CHIUSO == ordine.getStato() && allDone) {
            StatoOrdine.EVASO.cambiaStato(new StatoOrdine.OrdineContestoStato(ordine, context.getBarLayout()));
        }
    }
}
