package net.lucamasini.testcase.shared.dto.manager;

import net.lucamasini.testcase.shared.dto.StatoOrdine;
import net.lucamasini.testcase.shared.dto.StatoPiattoOrdinato;
import net.lucamasini.testcase.shared.entity.Ordine;
import net.lucamasini.testcase.shared.entity.Piatto;

import java.util.Arrays;

public class ServitoManager extends BackManager {
    @Override
    public void postChiuso(StatoOrdine.OrdineContestoStato context) {
        Ordine ordine = context.getOrdine();

        //caso in cui l'ordine non deve andare in cucina perchè non ha piatti cucina APERTI
        // e quindi posso evadere l'ordine e tutti i suoi piatti
        if (!ordine.hasPiattiForPreparazioneAndStato(Arrays.asList(Piatto.Preparazione.CUCINA), Arrays.asList(StatoPiattoOrdinato.APERTO))) {
            StatoOrdine.EVASO.cambiaStato(context);
        }
    }

    @Override
    public void postEvaso(StatoOrdine.OrdineContestoStato context) {
        Ordine ordine = context.getOrdine();
        // gli ordini del ServitoBack se vanno in evaso è perchè non hanno piatti cucina
        // e quelli che ci sono possono essere solo in stato Aperto e Cancellato
        ordine.getPiattiOrdinati().stream().filter(po -> po.getStato() == StatoPiattoOrdinato.APERTO)
            .forEach(po-> StatoPiattoOrdinato.EVASO.cambiaStato(new StatoPiattoOrdinato.PiattoOrdinatoContestoStato(po, context.getBarLayout())));
    }

}
