package net.lucamasini.testcase.shared.entity;

import net.lucamasini.testcase.shared.dto.Canale;
import net.lucamasini.testcase.shared.dto.manager.AbstractLayoutManager;
import net.lucamasini.testcase.shared.dto.manager.FrontManager;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public enum FlussoServizio {
    /**
     * Flusso previsto nei bar in cui non è presente il chiosco né il monitor numeri.
     */
    FRONT{
        @Override
        public AbstractLayoutManager getManager(Canale canale) {
            return new FrontManager();
        }
    },
    /**
     * Flusso previsto nei bar in cui è presente il chiosco (e di conseguenza anche il monitor numeri).
     */
    BACK{
        @Override
        public AbstractLayoutManager getManager(Canale canale) {
            return canale.getManager();
        }
    };

    public static List<FlussoServizio> getFlussi(Collection<String> strings) {
        List<FlussoServizio> stati = new ArrayList<>();
        for (String s : strings) {
            if(s!=null && !s.isEmpty()) {
                stati.add(FlussoServizio.valueOf(s.toUpperCase()));
            }
        }
        return stati;
    }

    public abstract AbstractLayoutManager getManager(Canale canale);
}
