package net.lucamasini.testcase.shared.entity;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;

@MappedSuperclass
@Getter
@Setter
public abstract class OrdbarGenericEntity {

    @Temporal(TemporalType.TIMESTAMP)
    @Column(updatable = false)
    Date dataInserimento;

    @Temporal(TemporalType.TIMESTAMP)
    Date dataAggiornamento;

    @Version
    long version;

    @PrePersist
    protected final void onPrePersist() {
        setDataInserimento(new Date());
        setDataAggiornamento(new Date());
        allineaRelazioni();

        postPrePersist();
    }

    protected void postPrePersist() {}

    @PreUpdate
    protected final void onPreUpdate() {
        setDataAggiornamento(new Date());
        allineaRelazioni();

        postPreUpdate();
    }

    protected void postPreUpdate() {}


    public abstract void allineaRelazioni();

}
