package net.lucamasini.testcase.shared.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.Comparator;


@Getter
@NoArgsConstructor
@EqualsAndHashCode
@Portable
public class PiattoOrdianatoInnerKey implements Comparable<PiattoOrdianatoInnerKey> {

    @JsonIgnore
    Ordine ordine;
    String nomeAbbinamento;
    String barcode;

    public PiattoOrdianatoInnerKey(Ordine ordine, String nomeAbbinamento) {
        this.ordine = ordine;
        this.nomeAbbinamento = nomeAbbinamento;
        this.barcode = ordine.getBarcode();
    }

    @Override
    public int compareTo(PiattoOrdianatoInnerKey o) {
        return Comparator
                .comparing(PiattoOrdianatoInnerKey::getBarcode)
                .thenComparing(PiattoOrdianatoInnerKey::getNomeAbbinamento)
                .compare(this, o);
    }
}
