package net.lucamasini.testcase.shared.entity;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.Comparator;

@Getter
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Portable
public class PiattoOrdinatoBackOuterKey extends PiattoOrdinatoOuterKey<PiattoOrdinatoBackOuterKey> {

    public PiattoOrdinatoBackOuterKey(String nomePiatto, String nota, boolean asporto) {
        super(nomePiatto, nota, asporto);
    }

    //Serve per fare il sort delle key nel raggruppamento
    @Override
    public int compareTo(PiattoOrdinatoBackOuterKey o) {
        return Comparator
                .comparing(PiattoOrdinatoBackOuterKey::getNomePiatto)
                .thenComparing(PiattoOrdinatoBackOuterKey::getNota)
                .thenComparing(PiattoOrdinatoBackOuterKey::isAsporto)
                .compare(this, o);
    }

}
