package net.lucamasini.testcase.shared.entity;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.Comparator;
import java.util.Date;

@Getter
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Portable
public class PiattoOrdinatoFrontOuterKey extends PiattoOrdinatoOuterKey<PiattoOrdinatoFrontOuterKey> {

    Date roundedDataInserimento;

    // Inserito costruttore per poter inizializzare i parametri del padre.
    public PiattoOrdinatoFrontOuterKey(String nomePiatto, String nota, boolean asporto, Date roundedDataInserimento) {
        super(nomePiatto, nota, asporto);
        this.roundedDataInserimento = roundedDataInserimento;
    }

    //Serve per fare il sort delle key nel raggruppamento
    @Override
    public int compareTo(PiattoOrdinatoFrontOuterKey o) {
        return Comparator
                .comparing(PiattoOrdinatoFrontOuterKey::getRoundedDataInserimento)
                .thenComparing(PiattoOrdinatoFrontOuterKey::getNomePiatto)
                .thenComparing(PiattoOrdinatoFrontOuterKey::getNota)
                .thenComparing(PiattoOrdinatoFrontOuterKey::isAsporto)
                .compare(this, o);
    }

}
