package net.lucamasini.testcase.shared.entity;

import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.jboss.errai.common.client.api.annotations.Portable;

import java.util.Comparator;

@Getter
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode
@Portable
public class PiattoOrdinatoTodoKey implements Comparable<PiattoOrdinatoTodoKey> {

    String nomePiatto;
    String numeroComanda;

    @Override
    public int compareTo(PiattoOrdinatoTodoKey o) {
        return Comparator.comparing(PiattoOrdinatoTodoKey::getNomePiatto)
                .thenComparing(PiattoOrdinatoTodoKey::getNumeroComanda)
                .compare(this, o);
    }
}
