package net.lucamasini.testcase.shared.serializers;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import net.lucamasini.testcase.shared.entity.Ordine;

import java.io.IOException;

public class OrdineSerializer extends JsonSerializer<Ordine> {

    @Override
    public void serialize(Ordine ordine, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException {
        jsonGenerator.writeStartObject();
        jsonGenerator.writeStringField("barcode", ordine.getBarcode());
        jsonGenerator.writeObjectField("stato", ordine.getStato());
        jsonGenerator.writeObjectField("canale", ordine.getCanale());
        jsonGenerator.writeObjectField("bar", ordine.getBar());
        jsonGenerator.writeStringField("numeroComanda", ordine.getNumeroComanda());
        jsonGenerator.writeBooleanField("asporto",ordine.isAsporto());
        jsonGenerator.writeBooleanField("prioritario", ordine.isPrioritario());
        jsonGenerator.writeEndObject();
    }
}