package net.lucamasini.testcase.shared.serializers;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import net.lucamasini.testcase.shared.entity.PiattoOrdinato;

import java.io.IOException;

public class PiattoOrdinatoSerializer extends JsonSerializer<PiattoOrdinato> {

    @Override
    public void serialize(PiattoOrdinato piattoOrdinato, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException {
        jsonGenerator.writeStartObject();
        jsonGenerator.writeNumberField("id", piattoOrdinato.getId());
        jsonGenerator.writeObjectField("stato", piattoOrdinato.getStato());
        jsonGenerator.writeObjectField("piatto", piattoOrdinato.getPiatto());
        jsonGenerator.writeNumberField("quantitaEvasa", piattoOrdinato.getQuantitaEvasa());
        jsonGenerator.writeNumberField("quantita", piattoOrdinato.getQuantita());
        jsonGenerator.writeStringField("nota", piattoOrdinato.getNota());

        jsonGenerator.writeEndObject();
    }
}
