package net.lucamasini.testcase.server.common;

import io.restassured.http.Method;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;
import net.lucamasini.testcase.shared.entity.BarLayout;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.ws.rs.core.Response;

@ApplicationScoped
public class BarLayoutDelegate {

    @Inject
    RequestDelegate requestDelegate;

    public BarLayout getLayout(String barId, Response.Status status) {
        RequestSpecification specification = requestDelegate.create();
        return requestDelegate.getResponse(specification, Method.GET, "/layout/bar/{id}", barId).then().statusCode(status.getStatusCode()).extract().as(BarLayout.class);
    }

    public ValidatableResponse salvaLayout(BarLayout layOut, Response.Status status) {
        RequestSpecification specification = requestDelegate.create(layOut);
        return requestDelegate.getResponse(specification, Method.POST, "/layout").then().statusCode(status.getStatusCode());
    }

    public void deleteLayout(BarLayout layout, Response.Status status) {
        RequestSpecification specification = requestDelegate.create(layout.getBar().getId());
        requestDelegate.getResponse(specification, Method.DELETE, "/layout/bar/{id}", layout.getBar().getId()).then().statusCode(status.getStatusCode());
    }
}
