package net.lucamasini.testcase.server.common;

import io.restassured.http.Method;
import io.restassured.response.ValidatableResponse;
import io.restassured.specification.RequestSpecification;
import net.lucamasini.testcase.shared.entity.Ordine;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.ws.rs.core.Response;

import static javax.ws.rs.core.Response.Status.OK;

@ApplicationScoped
public class OrdiniResourceDelegate {

    @Inject
    RequestDelegate requestDelegate;

    public Ordine salvaOrdine(Ordine ordine) {
        return salvaOrdine(ordine, OK).extract().as(Ordine.class);
    }

    public ValidatableResponse salvaOrdine(Ordine ordine, Response.Status status) {
        RequestSpecification specification = requestDelegate.create(ordine);
        return requestDelegate.getResponse(specification, Method.POST, "/ordini")
                .then().statusCode(status.getStatusCode());
    }

}
