package net.lucamasini.testcase.server.common;

import net.lucamasini.testcase.shared.entity.*;

import javax.enterprise.context.Dependent;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.transaction.Transactional;
import java.util.List;

@Dependent
@Transactional
public class TestEm {

    @Inject
    protected EntityManager em;

    public <T> void persist(T entity) {
        em.persist(entity);
    }

    public <T> T merge(T entity) {
        return em.merge(entity);
    }

    public void remove(Object entity) {
        em.remove(em.merge(entity));
    }

    public <T> List<T> findAll(Class<T> entityClass) {
        String query = "select e from " + entityClass.getSimpleName() + " e";
        return em.createQuery(query, entityClass).getResultList();
    }

    public <T> T findById(Class<T> entityType, Object id) {
        return em.find(entityType, id);
    }

    public void deleteAll(Class entityClass) {
        String query = "delete from " + entityClass.getSimpleName();
        em.createQuery(query).executeUpdate();
    }

    public EntityManager getEm() {
        return em;
    }

    @Transactional
    public void deleteAll() {
        deleteAll(Configurazione.class);
        deleteAll(Abbinamento.class);
        deleteAll(PiattoOrdinato.class);
        em.createNativeQuery("delete from ORDINE_MENU").executeUpdate();
        deleteAll(Ordine.class);
        deleteAll(MonitorPostazione.class);
        deleteAll(BarLayout.class);
        deleteAll(Bar.class);

    }
}
