package net.lucamasini.testcase.server.common.producers;

import net.lucamasini.testcase.server.producers.BarUtente;
import net.lucamasini.testcase.shared.dto.DatiUtente;
import net.lucamasini.testcase.shared.entity.Bar;

import javax.annotation.Priority;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.inject.Alternative;
import javax.enterprise.inject.Produces;
import javax.inject.Inject;

@Alternative
@Priority(500)
public class MockBarUtenteProducer {

    @Inject
    DatiUtente datiUtente;

    @Produces
    @BarUtente
    @RequestScoped
    public Bar barUtente() {

        return Bar.builder()
                .societa(datiUtente.getUserParameters().get(DatiUtente.SOCIETA))
                .numero(489L)
                .id(datiUtente.getIdBar()).build();
    }

}
