package net.lucamasini.testcase.server.common.producers;

import org.mockito.Mockito;

import javax.annotation.Priority;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.inject.Alternative;
import javax.enterprise.inject.Produces;
import javax.servlet.http.HttpServletRequest;

@ApplicationScoped
@Alternative
@Priority(100)
public class MockServletRequestProducer {

    private String ip = "127.0.0.1";

    @Produces
    @RequestScoped
    public HttpServletRequest mockHttpServletRequest() {
        HttpServletRequest mockRequest = Mockito.mock(HttpServletRequest.class);
        Mockito.when(mockRequest.getScheme()).thenReturn("http");
        Mockito.when(mockRequest.getServerName()).thenReturn("127.0.0.1");
        Mockito.when(mockRequest.getRemoteAddr()).thenReturn(ip);
        Mockito.when(mockRequest.getServerPort()).thenReturn(7001);
        Mockito.when(mockRequest.getHeader("X-FORWARDED-FOR")).thenReturn(ip);
        return mockRequest;
    }

    public void setIp(String ip){
        this.ip = ip;
    }

}
