package net.lucamasini.testcase.server.restassured;

import io.restassured.mapper.ObjectMapper;
import io.restassured.mapper.ObjectMapperDeserializationContext;
import io.restassured.mapper.ObjectMapperSerializationContext;
import net.lucamasini.testcase.server.control.FakeJsonb;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

@ApplicationScoped
public class RestAssuredObjectMapper implements ObjectMapper {

    @Inject
    FakeJsonb mapper;

    @Override
    public Object deserialize(ObjectMapperDeserializationContext context) {

        return mapper.fromJson(context.getDataToDeserialize().asInputStream(), context.getType());
    }

    @Override
    public Object serialize(ObjectMapperSerializationContext context) {
        return mapper.toJson(context.getObjectToSerialize());
    }
}
